<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import UserModule from "~/store/user";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { regexEmail } from "~/common/constaint";

@Component({})
export default class AuthLoginComponent extends Vue {
  userModule = getModule(UserModule, this.$store);

  loading = false;
  email: any = "";
  token: any = "";
  isSend = false;

  password = "";
  confirmPassword = "";

  isCreateNewPassword = false;

  isHidePassword = false;
  isHidePasswordReEnterpassword = false;

  created() {
    this.$router.push("/auth/login");
  }

  mounted() {
    const { token } = this.$route.query;
    if (token) {
      this.token = token;
    }
  }

  async onSendEmail() {
    try {
      if (!this.email) {
        return this.$pushNotification.error("Please enter email");
      }
      if (!regexEmail.test(this.email)) {
        return this.$pushNotification.error("Email not valid");
      }
      this.loading = true;
      const domain = window.location.host || "";
      await this.$api.user.forgotPassword(this.email, domain);
      this.isSend = true;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onCreateNewPassword() {
    try {
      if (!(this.password && this.confirmPassword)) {
        return this.$pushNotification.error("Please enter all field");
      }
      if (this.password.length < 6) {
        return this.$pushNotification.error(`Password must be greater than 6`);
      }
      if (this.password !== this.confirmPassword) {
        return this.$pushNotification.error(`Two passwords do not match`);
      }
      this.loading = true;
      const body = {
        password: this.password,
        token: this.token,
      };
      await this.$api.user.createNewPassword(body);
      this.password = "";
      this.confirmPassword = "";
      this.isCreateNewPassword = true;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }
}
</script>

<style>
#backgroundLinear {
  background: #f1f2f3;
}
</style>
